#version 330 core
layout (location = 0) in vec3 Position;
layout (location = 1) in vec3 Normal;
layout (location = 2) in vec2 aTexCoords;
layout (location = 3) in ivec4 BoneIDs;
layout (location = 4) in vec4 Weights;

const int MAX_BONES = 100;

uniform mat4 gBones[MAX_BONES];

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;

//out vec3 FragNormal;
//out vec3 FragPos;
out vec2 TexCoords;

void main()
{
	TexCoords = aTexCoords;
    //FragNormal = Normal;
    //FragPos = vec3(model * vec4(Position, 1.0));

	mat4 BoneTransform = gBones[BoneIDs[0]] * Weights[0];
    BoneTransform += gBones[BoneIDs[1]] * Weights[1];
    BoneTransform += gBones[BoneIDs[2]] * Weights[2];
    BoneTransform += gBones[BoneIDs[3]] * Weights[3];
    
	vec4 PosL = BoneTransform * vec4(Position, 1.0);
	//vec4 PosL = vec4(Position, 1.0) + BoneTransform * vec4(Position, 1.0);
	//vec4 PosL = vec4(Position, 1.0);
	gl_Position = projection * view * model * PosL;
	//gl_Position = projection * view * model * vec4(Position, 1.0);
}